package client;

import java.net.Socket;
import java.util.Random;

import common.ConnectionRequestClientPacket;

public class PendingConnection {
	private ConnectionRequestClientPacket request;
	private long timeLastAsked;
	private Socket socket;
	
	public PendingConnection(ConnectionRequestClientPacket request, Socket socket) {
		this.request = request;
		this.timeLastAsked = 0;
		this.socket = socket;
	}

	public boolean hasBeenRequested(int reaskTimeout) {
		return (System.currentTimeMillis() - timeLastAsked) > reaskTimeout;
	}

	public ConnectionRequestClientPacket getRequestForSending() {
		request.setChallengeId(new Random().nextInt());
		timeLastAsked = System.currentTimeMillis();
		return request;
	}

	public long getTimeLastAsked() {
		return timeLastAsked;
	}

	public boolean isTCP() {
		return (request.getRequestFlags() & ConnectionRequestClientPacket.FLAG_TCP) != 0;
	}

	public Socket getSocket() {
		return socket;
	}

	public int getChallengeId() {
		return request.getChallengeId();
	}
}
